﻿CONST
    APP_NAME = 'Assistant Secretary';
var
  Found: Boolean;

procedure frmRegKey_OnClose (Sender: string; Action: string);
begin
    If Found = False then frmDashboard.Close;
end;

procedure frmDashboard_OnShow (Sender: string; Action: string);
var
  reg: TRegistry;
  DaysLeft: Integer;
begin
  frmDashboard.mniAbout.Visible := False;
  frmDashboard.mniimportdata.caption := 'Clear Tables';
  frmDashboard.mniimportdata.OnClick := @clear_tables;
  reg := TRegistry.Create;
  reg.Access := KEY_ALL_ACCESS;
  reg.RootKey := HKEY_CURRENT_USER;
  reg.OpenKey('software\'+APP_NAME,true);
  if not reg.ValueExists('Run') then
    Begin
       reg.CloseKey;
       reg.Free;
       frmReg_Key.ShowModal;
    End else
    Begin
      If reg.ValueExists('EndDate') then
        Begin
          Daysleft := Trunc(reg.ReadDate('EndDate')) - Trunc(Now);
          frmDashboard.lblDaysLeft.Caption := 'Days left till this software rental expires: ' + IntToStr(DaysLeft);
          frmDashboard.lblExpiration.Caption := 'Expiration: ' + DateToStr(Trunc(reg.ReadDate('EndDate')));
          reg.CloseKey;
          reg.Free;
          If DaysLeft < 1 then
            Begin
              MessageBox('Your software rental has expired','Expired',MB_OK+MB_ICONWARNING);
              frmDashboard.Close
            End;
        End else
        Begin
         frmDashboard.lblDaysLeft.Caption := '';
         frmDashboard.lblExpiration.Caption := '';
         reg.CloseKey;
         reg.Free;
        End;
    End;
end;

procedure frmRegKey_btnOk_OnClick (Sender: string; var Cancel: boolean);
var
  i: Integer;
  sKey,Duration: String;

  reg: TRegistry;
  Keys: array of string;
  Array_len,NoOfKeys,Days: Integer;
begin
    Found := False;

    // Define your keys and duration in days here
    NoOfKeys := 15;    // Number of keys - if you add more keys below then you need to update this value
    Array_Len := 480;  // Total character length of all keys and days - if you add more keys below then you need to update this value
    Setlength(Keys,Array_Len);
    Keys[0] := 'Yh6W4-3UASY-H4x4s-crxWU-8WLfG364';
    Keys[1] := 'UnfGk-DoZLD-52mcC-uheZu-8vu8K364';
    Keys[2] := 'oM9aF-JTAn3-39pFp-D8DuM-FLjg8364';
    Keys[3] := 'iKeGt-oQSRQ-2qnWg-w6EKu-Gxuve364';
    Keys[4] := 'gBRkG-RsEAx-5VzGB-QRPjd-Br4eF364';
    Keys[5] := 'PBJTq-TfR5q-mwCUt-WNL65-jzZvW364';
    Keys[6] := 'AFMXi-TpbJV-DZjNd-QRYB8-T5jH3364';
    Keys[7] := 'Z46tv-xYSsJ-uYEdk-SHMFw-mC2ST364';
    Keys[8] := '9AsbE-p2UnV-iY6Nu-ipRfp-GJwjq364';
    Keys[9] := 'wxc2B-o6MmB-vebxF-i5fen-zfPKs364';
    Keys[10] := 'RuAJx-erodU-M8iVd-EFmfV-LGR35364';
    Keys[11] := 'UTGxW-xCsBr-6hy6k-sBDtC-KryjB364';
    Keys[12] := '5Sr54-wmnwB-Yi6fY-epKBc-Jsubm364';
    Keys[13] := 'bEwF8-LwZb9-KRVeJ-tm9Hg-mALRg364';
    Keys[14] := 'EWwCd-8qTeb-ggwx5-8uyw2-pyYA3364';
    // End Definition

    If frmReg_Key.edKey.Text = '' then
      Begin
        MessageBox('Registration Key is Required','Error',MB_OK+MB_ICONERROR);
        frmReg_Key.edKey.SetFocus;
        Exit;
      End;


    For i := 0 to NoOfKeys - 1 do
      Begin
         sKey := Copy(Keys[i],1,29);
         If frmReg_Key.edKey.Text = sKey then
           Begin
              Found := True;
              Duration := Copy(Keys[i],30,3);
              Break;
           End;
      End;
     If Found = True then
       Begin
         reg := TRegistry.Create;
         reg.Access := KEY_ALL_ACCESS;
         reg.RootKey := HKEY_CURRENT_USER;
         reg.OpenKey('software\'+APP_NAME,true);
         reg.WriteString('Run', '...');
         If Duration <> '999' then reg.WriteDate('EndDate', Now+StrToInt(Duration));
         reg.CloseKey;
         reg.Free;
         Days := StrToInt(Duration);
         frmDashboard.lblDaysLeft.Caption := '';
         frmDashboard.lblExpiration.Caption := '';
         If Duration <> '999' then
           Begin
             frmDashboard.lblDaysLeft.Caption := 'Days left till this software rental expires: ' + IntToStr(Days);
             frmDashboard.lblExpiration.Caption := 'Expiration: ' + DateToStr(Date + Days);
           End;
         frmReg_Key.Close;
       End else
       Begin
         MessageBox('Not a valid Key','Error',MB_OK+MB_ICONERROR);
         frmReg_Key.edKey.SetFocus;
       End;
end;                                   

procedure frmReg_Key_btnCancel_OnAfterClick (Sender: string);
begin
   frmDashboard.Close;
end;

procedure clear_tables;
begin
  frmDashboard.BtnClear.click;
end;

procedure frmClr_Tbls_OnShow (Sender: TObject; Action: string);
begin
  frmClr_Tbls.button1.click;
end;

procedure frmClr_Tbls_TableGrid1_OnCellClick (Sender: TObject; ACol, ARow: Integer);
begin
If MessageBox('Delete All Data From The Highlighted Table?','Confirm',MB_YESNO+MB_ICONQUESTION) = IDYES then
  begin
    sqlexecute('delete from "'+frmClr_Tbls.tablegrid1.cells[0,arow]+'"');
  end;
  frmClr_Tbls.button1.click;
end;

procedure frmClr_Tbls_TableGrid1_OnChange (Sender: TObject);
var  vi: integer;
begin
  for vi := 0 to frmClr_Tbls.tablegrid1.RowCount-1 do
    begin
      frmClr_Tbls.tablegrid1.cells[1,vi] := sqlexecute('select count(*) from "'+frmClr_Tbls.tablegrid1.cells[0,vi]+'"');
  end;

end;

//Registration Keys


begin
end.




